/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	MakeContentsMenuScreenAction
//	変更履歴
//		2004.02.01	新規作成
//

package jp.co.ntt.lms.lo.scorm.engine;

import java.io.File;

import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.xml.transform.Templates;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.stream.StreamSource;

import jp.co.ntt.lms.lo.scorm.util.SG;
import jp.co.ntt.lms.xms.framework.XmsException;
import jp.co.ntt.lms.xms.framework.XmsRequest;
import jp.co.ntt.lms.xms.framework.XmsResponse;
import jp.co.ntt.lms.xms.framework.XmsScreenAction;
import jp.co.ntt.lms.xms.framework.XmsSystemException;

/**
 *	MakeContentsMenuScreenAction クラス<br>
 *	目次フレームの画面表示を行う際に実行されるクラス<br>
 */
public class MakeContentsMenuScreenAction extends XmsScreenAction {
	/**
	 * デフォルトコンストラクタ
	 */
	public MakeContentsMenuScreenAction() {}

	/**
	 * 初期化処理
	 *
	 * @param	xmsRequest	リクエストオブジェクト
	 * @param	xmsResponse	レスポンスオブジェクト
	 */
	protected void initProcessRequest(XmsRequest xmsRequest, XmsResponse xmsResponse) throws XmsException {}

	/**
	 * 目次フレーム作成要求画面作成処理
	 *
	 * @param	xmsRequest	リクエストオブジェクト
	 * @param	xmsResponse	レスポンスオブジェクト
	 */
	protected void processRequest(XmsRequest xmsRequest, XmsResponse xmsResponse) throws XmsException {
		HttpServletRequest request = xmsRequest.getRequest();
		HttpSession session = request.getSession();
		ServletContext application = session.getServletContext();

		try {
			// BusinessBeanを取得する
			XSLTBusinessBean XSLTBusinessBean = (XSLTBusinessBean)xmsResponse.getBusinessBean();

			// 起動パラメータを取得する
			ExecuteParameters executeParameters = XSLTBusinessBean.getExecuteParameters();

			String xslFilename;

			// Templatesをキャッシュから取得する
			Templates templates =
				(Templates)ContentsInfoCacher.get("ContentsMenuTemplates", executeParameters.getManifestID());

			// キャッシュにTemplatesが存在しない場合
			if (templates == null) {
				// カスタマイズされた目次出力xslへのフルパスを作成する
				StringBuffer customContentsMenuURL = new StringBuffer();

				customContentsMenuURL.append(SG.get("ContentsBaseURL"));
				customContentsMenuURL.append(executeParameters.getManifestID());
				customContentsMenuURL.append(File.separator);
				customContentsMenuURL.append("_customize");
				customContentsMenuURL.append(File.separator);
				customContentsMenuURL.append("ContentsMenu.xsl");

				xslFilename = customContentsMenuURL.toString();

				// カスタマイズされた目次出力xslが存在する場合
				if (new File(xslFilename).exists()) {
					// Templatesを作成する
					templates = TransformerFactory.newInstance().newTemplates(new StreamSource(xslFilename));
				}
				// カスタマイズされた目次出力xslが存在しない場合
				else {
					// デフォルトの目次出力xslへのURLを作成する
					StringBuffer defaultContentsMenuXSLURL = new StringBuffer();

					defaultContentsMenuXSLURL.append(SG.get("ContentsBaseURL"));
					defaultContentsMenuXSLURL.append("_default");
					defaultContentsMenuXSLURL.append(File.separator);
					defaultContentsMenuXSLURL.append("DefaultContentsMenu.xsl");

					xslFilename = defaultContentsMenuXSLURL.toString();

					synchronized (ContentsInfoCacher.class) {
						templates = (Templates)ContentsInfoCacher.get("ContentsMenuTemplates", "");

						// デフォルトの目次出力xslもキャッシュに存在しなかった場合
						if (templates == null) {
							// Templatesを作成する
							templates = TransformerFactory.newInstance().newTemplates(new StreamSource(xslFilename));

							// キャッシュにTemplatesを設定する
							ContentsInfoCacher.set(
								"ContentsMenuTemplates",
								"",
								templates,
								new ContentsInfoCacher.FileValidateChecker(xslFilename));
						}
					}
				}

				// キャッシュにTemplatesを設定する
				ContentsInfoCacher.set(
					"ContentsMenuTemplates",
					executeParameters.getManifestID(),
					templates,
					new ContentsInfoCacher.FileValidateChecker(xslFilename));
			}

			Transformer transformer;

			synchronized (templates) {
				transformer = templates.newTransformer();
			}

			XSLTScreenBean XSLTScreenBean = new XSLTScreenBean();

			XSLTScreenBean.setTransformer(transformer);

			xmsResponse.setScreenBean(XSLTScreenBean);
		}
		catch (Exception ex) {
			throw new XmsSystemException(ex);
		}
	}
}
